; Bitmap rotation engine, v1.0
; by Maple Leaf, 22 Oct 96
;
; Version works for 320x200 bitmaps
; --------------------------------------------------------------------------
; This is the very first asm implementation of the engine. It really isn't
; optimized, you know ?... well, if you want something a little bit better
; you may use ROTASM2 (that one can be further optimized, too!)
; --------------------------------------------------------------------------
; asm rules, yup yup! the others suck!

.model TPascal
.386
.DATA

        extrn    _Ax_ : DWORD
        extrn    _Ay_ : DWORD
        extrn    _Bx_ : DWORD
        extrn    _By_ : DWORD
        extrn    _Cx_ : DWORD
        extrn    _Cy_ : DWORD
        extrn    HAdvX : DWORD
        extrn    HAdvY : DWORD
        extrn    VAdvX : DWORD
        extrn    VAdvY : DWORD
        extrn    _Lx_  : DWORD
        extrn    _Ly_  : DWORD
        extrn    _Sx_  : DWORD
        extrn    _Sy_  : DWORD
        extrn    vScr:WORD
        extrn    Img:DWORD
        extrn    RowOffs:BYTE
        extrn    Angle:BYTE
        extrn    WW:DWORD
        extrn    WH:DWORD
        extrn    CosTab:DWORD
        extrn    SinTab:DWORD

.CODE

        public   GenFrame

include jumps.inc

;****************************************************************************

proc    ComputeFramePara near

        push     eax ecx edx si di

        mov      al,Angle
        movzx    si,al
        add      al,64     ; Angle+90 in a 360-deg system
        movzx    di,al

        shl      si,2
        shl      di,2      ; indexes in SinTab/CosTab

        mov      eax,WH
        xor      edx,edx
        mov      ecx,dword ptr CosTab[si]
        imul     ecx
        shrd     eax,edx,8
        add      eax,_Ax_  ; eax = _ax_ + WH * cos (angle)
        mov      _Bx_,eax  ; store result

        mov      eax,WH
        xor      edx,edx
        mov      ecx,dword ptr SinTab[si]
        imul     ecx
        shrd     eax,edx,8
        sub      eax,_Ay_  ; eax = _ay_ - WH * sin (angle)
        neg      eax
        mov      _By_,eax  ; store result

        mov      eax,WW
        xor      edx,edx
        mov      ecx,dword ptr CosTab[di]
        imul     ecx
        shrd     eax,edx,8
        add      eax,_Ax_  ; eax = _ax_ + WW * cos (angle+90)
        mov      _Cx_,eax  ; store result

        mov      eax,WW
        xor      edx,edx
        mov      ecx,dword ptr SinTab[di]
        imul     ecx
        shrd     eax,edx,8
        sub      eax,_Ay_  ; eax = _ay_ - WW * sin (angle+90)
        neg      eax
        mov      _Cy_,eax  ; store result

        mov      eax,_Cx_
        sub      eax,_Ax_
        shl      eax,16
        cdq
        mov      ecx,320
        idiv     ecx
        mov      hAdvX,eax  ; hAdvX = ((_cx_-_ax_) shl 16) div 320

        mov      dword ptr cs:smc1+2,eax  ; SMCODE INIT

        mov      eax,_cy_
        sub      eax,_ay_
        shl      eax,16
        cdq
        mov      ecx,320
        idiv     ecx
        mov      hAdvY,eax  ; hAdvY = ((_cy_-_ay_) shl 16) div 320

        mov      dword ptr cs:smc2+3,eax

        mov      eax,_bx_
        sub      eax,_ax_
        shl      eax,16
        cdq
        mov      ecx,200
        idiv     ecx
        mov      vAdvX,eax  ; vAdvX = ((_bx_-_ax_) shl 16) div 200

        mov      eax,_by_
        sub      eax,_ay_
        shl      eax,16
        cdq
        mov      ecx,200
        idiv     ecx
        mov      vAdvY,eax  ; vAdvY = ((_by_-_ay_) shl 16) div 200

        pop      di si edx ecx eax

        retn
        endp

;****************************************************************************

GenFrame proc     near

        call     ComputeFramePara

        push     es fs
        pushad

        mov      es,vScr
        mov      fs,Img[2]

        xor      di,di

        mov      eax,_ax_
        shl      eax,16
        mov      _lx_,eax

        mov      ebx,_ay_
        shl      ebx,16
        mov      _ly_,ebx

;-- Loop 1 (200 times) ------------------------------------------------------
        mov      cx,200

Loop1:  push     cx

;-- Loop 2 (320 times) ------------------------------------------------------
        mov      cx,320
Loop2:  mov      esi,ebx
        shr      esi,16

        add      si,si
        mov      si,word ptr RowOffs[si]

;        shl      si,6
;        mov      dx,si
;        shl      si,2
;        add      si,dx

        mov      edx,eax
        shr      edx,16
        add      si,dx

        mov      dl,fs:[si]   ; should be optimized (DS instead of FS, it is faster!)
        mov      es:[di],dl
        inc      di

smc1:   add      eax,12345678h ;hAdvX
        sjge     e5
        add      eax,1400000h
e5:
smc2:   add      ebx,12345678h ;hAdvY
        sjge     e6
        add      ebx,0C80000h

e6:     cmp      eax,1400000h
        sjl      e7
        sub      eax,1400000h

e7:     cmp      ebx,0C80000h
        sjl      e8
        sub      ebx,0C80000h
e8:
        dec      cx
        sjg      Loop2

;-- End loop 2 --------------------------------------------------------------

        pop      cx

        mov      eax,_lx_
        mov      ebx,_ly_

        add      eax,vAdvX
        sjge     e1
        add      eax,1400000h

e1:     add      ebx,vAdvY
        sjge     e2
        add      ebx,0C80000h

e2:     cmp      eax,1400000h
        sjl      e3
        sub      eax,1400000h

e3:     cmp      ebx,0C80000h
        sjl      e4
        sub      ebx,0C80000h

e4:     mov      _lx_,eax
        mov      _ly_,ebx

        dec      cx
        jg       Loop1

;-- End loop 1---------------------------------------------------------------

        popad
        pop      fs es

        retn
        endp


        END
